Load Data Sets

Use the load vectors operation to perform bulk loads of vectors from a CSV file in Oracle Object Storage.

The operation appends vector records from Oracle Object Storage into an existing vector table asynchronously. The table must already exist. For integrated embedding tables, the table’s embed_params configuration is used to generate embeddings when needed.

The object storage URL provided as a parameter should point to a CSV file with the following format:

id,dense_vector,metadata
id1,[0.1, 0.2, 0.3],{"field1": "value1", "field2": "value2"}
id2,[0.4, 0.5, 0.6],{"field1": "value3", "field2": "value4"}

Guidelines for preparing CSV files for loading data set:

A JSON response is returned containing the load job ID and initial status.

See the following for an example of bulk loading vectors from Oracle Object Storage and monitoring the load process.

First load vectors from object storage into a variable called load_job, then use describe_vector_load_job to monitor the load process:

from oracle_vecdb import OracleVecDB, Configuration

client = OracleVecDB(Configuration(
    rest_url="https://<host>/ords/<schema>/_/db-api/stable/vecdb/",
    access_token="<bearer-token>", # or username="<user>", password="<pass>"
))

load_job = client.load_vectors(
    table_name='products',
    url='https://objectstorage.region.oraclecloud.com/.../vectors.csv',
    params={'credential': 'OCI_CREDENTIAL'}
)

job_status = client.describe_vector_load_job(
    load_job_name=load_job.job_name
)
print(job_status.to_dict())

if job_status.state == "FAILED":
    job_log = client.get_vector_load_job_log(
        load_job_name=load_job.job_name
    )
    print(job_log.to_dict())

Example response:

{
  "job_name": "VECDB_LOAD_ABC123",
  "job_creator": "VECTOR3",
  "operation": "LOAD",
  "state": "SUCCEEDED",
  "links": [
      {
          "rel": "collection",
          "href": "https://<host>/ords/<schema>/_/db-api/stable/vecdb/load/jobs/"
      },
      {
          "rel": "self",
          "href": "https://<host>/ords/<schema>/_/db-api/stable/vecdb/load/jobs/vecdb_load_abc123/"
      },
      {
          "rel": "related",
          "href": "https://<host>/ords/<schema>/_/db-api/stable/vecdb/load/jobs/vecdb_load_abc123/jobfile"
      }
  ]
}

For more information about the load_vectors operation, see Python API Reference.

See how POST /vecdb/load can be used in the following example:

curl -X POST \
  "https://<host>:<port>/ords/<schema>/_/db-api/stable/vecdb/load" \
  -H "Content-Type: application/json" \
  -H "Accept: application/json" \
  # Choose ONE authentication method:

  # Option 1: Basic authentication
  -u "<user>:<password>" \

  # Option 2: OAuth Bearer token
  # -H "Authorization: Bearer <access_token>" \

  -d '{
    "tableName": "product_vectors",
    "url": "https://objectstorage.example.com/data/product_vectors.csv",
    "params": {
      "credential": "OBJ_STORE_CRED"
    }
  }'

Responses:

  • Example 200 response:

    {
      "job_creator": "APPUSER",
      "job_name": "VECDB_LOAD_20260501110000",
      "job_type": "PLSQL_BLOCK",
      "operation": "LOAD",
      "state": "SCHEDULED",
      "start_date": "2026-05-01T11:00:00.118886Z",
      "links": [
        {
          "href": "/vecdb/load/jobs/",
          "rel": "collection"
        },
        {
          "href": "/vecdb/load/jobs/vecdb_load_20260501110000/",
          "rel": "self"
        },
        {
          "href": "/vecdb/load/jobs/vecdb_load_20260501110000/jobfile",
          "rel": "related"
        }
      ]
    }
  • 400 - the request body included invalid parameters.

For more information about POST /vecdb/load, see REST API Reference.

See how DBMS_VECTOR_DATABASE.LOAD_VECTORS can be used in the following example:

dbms_vector_database.load_vectors(
    table_name => 'product_vectors',
    url => 'https://objectstorage.example.com/data/product_vectors.csv',
    params => JSON('{"credential": "OBJ_STORE_CRED"}')
);

Example response:

{
  "table_name": "PRODUCT_VECTORS",
  "file_url": "https://objectstorage.example.com/data/product_vectors.csv"
}

For more information about the PL/SQL implementation, including parameters, see LOAD_VECTORS.